<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@page import="org.wso2.carbon.security.ui.client.SecurityAdminClient" %>
<%@page
        import="org.wso2.carbon.security.ui.config.xsd.SecurityScenarioData" %>
<%@page import="org.wso2.carbon.utils.ServerConstants" %>
<%@page import="org.wso2.carbon.CarbonConstants" %>
<%@page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="java.text.MessageFormat" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.security.ui.config.xsd.SecurityScenarioDataWrapper" %>


<%@page import="java.util.ResourceBundle"%><script type="text/javascript" src="extensions/js/vui.js"></script>
<script type="text/javascript" src="../admin/js/main.js"></script>
<jsp:include page="../dialog/display_messages.jsp"/>
<%
	String BUNDLE = "org.wso2.carbon.security.ui.i18n.Resources";
	ResourceBundle resourceBundle = ResourceBundle.getBundle(BUNDLE, request.getLocale());
    String[] options = new String[]{"Yes", "No"};
    String[] optionsValues = new String[]{resourceBundle.getString("yes"), resourceBundle.getString("no")};
%>
<%!
    String info = null;
    SecurityScenarioData[] scenarios = null;
%>
<%!
    String showOption = null;
    String displayStyle = null;
    int[] optionsOrder = null;

%>
<%!
    private void checkScenarioID(int scenarioIdDisplay, SecurityScenarioData scenario) {
        if(!("scenario" + scenarioIdDisplay).equals(scenario.getScenarioId())){
            throw new RuntimeException("ScenarioID & generated ID for scenario " +
                                       scenario.getSummary() + " do not match. Scenario ID: " +
                                       scenario.getScenarioId() +", generated ID:" + scenarioIdDisplay);
        }
    }
%>
<%
	SecurityScenarioData currentScenario;
    String serviceName;
    serviceName = request.getParameter("serviceName");
    if (serviceName != null) {
        serviceName = serviceName.trim();
        if (serviceName.length() > 0) {
            session.setAttribute("serviceName", serviceName);
        }
    } else {
        serviceName = (String) session.getAttribute("serviceName");
    }

    if (serviceName == null) {
        String message = resourceBundle.getString("cannot.proceed.please.select.a.service.to.enable.security");
		CarbonUIMessage uiMsg = new CarbonUIMessage(message, CarbonUIMessage.ERROR, null);
		session.setAttribute(CarbonUIMessage.ID, uiMsg);
	%>
	<jsp:include page="../admin/error.jsp"/>
	<%
		return;
    }
    
	try {
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        ConfigurationContext configContext =
                (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        SecurityAdminClient client = new SecurityAdminClient(cookie, backendServerURL, configContext);
        SecurityScenarioDataWrapper scenarioDataWrapper = client.getScenarios(serviceName);
        scenarios = scenarioDataWrapper.getScenarios();
        currentScenario = scenarioDataWrapper.getCurrentScenario();

        if (currentScenario == null) {
            info = MessageFormat.format(resourceBundle.getString("service.not.secured"),
                                        serviceName);
            optionsOrder = new int[]{1, 0};
            displayStyle = "display: none;";
        } else {
            info = MessageFormat.format(resourceBundle.getString("service.secured.using"),
                                        serviceName, currentScenario.getSummary());
            optionsOrder = new int[]{0, 1};
            displayStyle = "display: inline;";
        }
    } catch (Exception e) {
        CarbonUIMessage uiMsg = new CarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
        <jsp:include page="../admin/error.jsp"/>
<%
        return;
    }
%>

<fmt:bundle basename="org.wso2.carbon.security.ui.i18n.Resources">
<carbon:breadcrumb label="security.for.the.service"
                   resourceBundle="org.wso2.carbon.security.ui.i18n.Resources"
                   topPage="false" request="<%=request%>"/>
                   <script type="text/javascript">


    function doValidation() {
        var isChecked = false;
        isChecked = isAtleastOneChecked("scenarioId");
        if (!isChecked) {
            CARBON.showWarningDialog('<fmt:message key="please.select.at.leaset.one.security.scenario"/>');
        }
        return isChecked;
    }


    function showOptions() {
        var temp = document.getElementById("securityConfiguration");
        if (document.getElementById("securityConfigAction").value == "Yes") {
            temp.style.display = "inline";
        } else if (document.getElementById("securityConfigAction").value == "No") {
            CARBON.showConfirmationDialog("<fmt:message key="disable.security.confirm"/>",
                    function() {
                        document.deleteSecurity.submit();
                    },
                    function() {
                        document.getElementById("securityConfigAction").value = "Yes";
                        temp.style.display = "inline";
                    });
        }
    }


</script>
<div id="middle">
    <h2><fmt:message key="security.for.the.service"/></h2>

    <div id="workArea">
        <p><%=info%></p>

        <p>&nbsp;</p>

        <table>
            <tr>
                <td><fmt:message key="enable.security"/>?</td>
                <td>
                    <select onchange="showOptions();" id="securityConfigAction" name="enable">
                        <%
                            for (int optionOder : optionsOrder) {
                        %>
                        <option value="<%=options[optionOder]%>"><%=optionsValues[optionOder]%>
                        </option>
                        <%
                            }
                        %>
                    </select>
                </td>
            </tr>
        </table>
        <p>&nbsp;</p>

        <div id="securityConfiguration" style="<%=displayStyle%>">
            <form id="secConfigForm" name="securityForm" method="post" action="ut-ks-advance.jsp"
                  onsubmit="return doValidation();">
                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th colspan="4"><fmt:message key="basic.scenarios"/></th>
                    </tr>
                    </thead>
                    <tbody>
                    <%
                        int scenarioIdDisplay = 1;
                        for (SecurityScenarioData scenario : scenarios) {
                            if (scenario != null) {
                                String id = scenario.getScenarioId();
                                if (!scenario.getType().equals("basic")){
                                continue;
                            }
                            checkScenarioID(scenarioIdDisplay, scenario);
                    %>
                    <tr>
                        <td><%= scenarioIdDisplay++ %>.</td>
                        <td>
                            <%
                                if (currentScenario != null &&
                                    currentScenario.getScenarioId().equals(id)) {
                            %><input type="radio" name="scenarioId" value="<%=id%>"
                                     checked="checked"/><%
                        } else {
                        %><input type="radio" name="scenarioId" value="<%=id%>"/><%
                            }
                        %>
                        </td>
                        <td>
                            <%= scenario.getSummary() %>
                        </td>
                        <td><%=scenario.getDescription()%>
                        </td>
                    </tr>
                    <%
                            }
                        }
                    %>
                    <tr><td colspan="4">&nbsp;</td></tr>
                    <tr>
                        <td colspan="4" class="sub-header"><fmt:message
                                key="advanced.scenarios"/></td>
                    </tr>
                    <%
                       for (SecurityScenarioData scenario: scenarios) {
                           if (scenario != null) {
                               String id = scenario.getScenarioId();
                               if (!scenario.getType().equals("advanced")) {
                                   continue;
                            }
                           checkScenarioID(scenarioIdDisplay, scenario);
                    %>
                    <tr>
                        <td><%= scenarioIdDisplay++ %>.</td>
                        <td>
                            <%
                                if (currentScenario != null &&
                                    currentScenario.getScenarioId().equals(id)) {
                            %><input type="radio" name="scenarioId" value="<%=id%>"
                                     checked="checked"/><%
                        } else {
                        %><input type="radio" name="scenarioId" value="<%=id%>"/><%
                            }
                        %>
                        </td>
                        <td><%=scenario.getSummary()%>
                        </td>
                        <td><%=scenario.getDescription()%>
                        </td>
                    </tr>
                    <%
                            }
                        }
                    %>
                    <tr>
                        <td class="buttonRow" colspan="4">
                            <input class="button" type="submit"
                                   value="<fmt:message key="next"/> >"/>
                        </td>
                    </tr>
                    </tbody>
                </table>

            </form>
        </div>
        <div id="divDeleteSecurity" style="display: none">
            <form name="deleteSecurity" action="remove-security.jsp">
                <input type="submit" value="<fmt:message key="delete"/>"/>
            </form>
        </div>

    </div>
</div>
</fmt:bundle>