<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@page import="org.wso2.carbon.security.ui.client.KeyStoreAdminClient" %>
<%@page import="org.wso2.carbon.security.ui.keystore.xsd.KeyStoreData" %>
<%@page import="org.wso2.carbon.security.ui.client.SecurityAdminClient" %>
<%@page import="org.wso2.carbon.security.ui.config.xsd.SecurityScenarioData" %>
<%@page import="org.wso2.carbon.security.ui.config.xsd.SecurityConfigData" %>
<%@page import="java.util.List" %>
<%@page import="java.util.ArrayList" %>
<%@page import="java.util.Arrays" %>
<%@page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@page import="org.apache.axis2.context.ConfigurationContext" %>
<%@page import="org.wso2.carbon.CarbonConstants" %>
<%@page import="org.wso2.carbon.user.mgt.common.FlaggedName"%>

<%@page import="org.wso2.carbon.user.mgt.ui.UserAdminClient"%>
<link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
<script type="text/javascript" src="extensions/js/vui.js"></script>
<script type="text/javascript" src="../../main/admin/js/main.js" type="text/javascript"></script>
<script type="text/javascript" src="../../main/admin/js/breadcrumbs.js"></script>
<script type="text/javascript" src="../../main/admin/js/cookies.js"></script>
<jsp:include page="../dialog/display_messages.jsp"/>

<fmt:bundle basename="org.wso2.carbon.security.ui.i18n.Resources">
<carbon:breadcrumb label="activate.security"
                   resourceBundle="org.wso2.carbon.security.ui.i18n.Resources"
                   topPage="false" request="<%=request%>"/>

<script type="text/javascript">
    function doValidation() {
        var isChecked = false;
        isChecked = isAtleastOneCheckedIfExisting("userGroups");
        if (isChecked != true) {
            CARBON.showWarningDialog("<fmt:message key="please.select.at.leaset.one.user.group"/>");
            return false;
        }

        isChecked = isAtleastOneCheckedIfExisting("trustStore");
        if (isChecked != true) {
            CARBON.showWarningDialog("<fmt:message key="please.select.at.least.one.trust.store"/>");
            return false;
        }

        return true;
    }
</script>
            <%
                FlaggedName[] groupData = null;
                KeyStoreData[] datas = null;
                String curr_pvtks = "";
                List<String> curr_tstks = new ArrayList<String>();
                List<String> curr_ugs = new ArrayList<String>();
                String category = null;
                boolean fault = false;

                String scenId = request.getParameter("scenarioId");
                if (scenId != null) {
                    session.setAttribute("scenarioId", scenId);
                } else {
                    /**
                     * This is needed for proper functionality of breadcrumbs. If the user goes
                     * forward and clicks on "Activate Security" breadcrumb, scenario Id can only
                     * be accessed from the session.
                     */
                    scenId = (String) session.getAttribute("scenarioId");
                }

                try {
                    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
                    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
                    ConfigurationContext configContext =
                            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
                    SecurityAdminClient secClient = new SecurityAdminClient(cookie, backendServerURL, configContext);
                    SecurityScenarioData scenData = secClient.getSecurityScenario(scenId);

                    String serviceName = (String) session.getAttribute("serviceName");

                    SecurityConfigData configData = secClient.getSecurityConfigData(serviceName, scenId);
                    //place holders for existing configs
                    if (configData != null) {
                        if (configData.getPrivateStore() != null) {
                            curr_pvtks = configData.getPrivateStore();
                        }

                        if (configData.getTrustedKeyStores() != null &&
                                configData.getTrustedKeyStores().length > 0 &&
                                configData.getTrustedKeyStores()[0] != null) {
                            curr_tstks = Arrays.asList(configData.getTrustedKeyStores());
                        }

                        if (configData.getUserGroups() != null &&
                                configData.getUserGroups().length > 0 &&
                                configData.getUserGroups()[0] != null) {
                            curr_ugs = Arrays.asList(configData.getUserGroups());
                        }

                    }


                    category = scenData.getCategory();

                    if (category.contains("ut")) {
                        UserAdminClient client = new UserAdminClient(cookie, backendServerURL, configContext);
                        groupData = client.getAllRolesNames();
                    }

                    if (category.contains("keystore")) {
                        KeyStoreAdminClient client = new KeyStoreAdminClient(cookie, backendServerURL, configContext);
                        datas = client.getKeyStores();
                    }

                } catch (Exception e) {
                     fault = true;
                     CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
                <script type="text/javascript">
                    location.href = "../admin/error.jsp";
                </script>
<%
                }
    if(!fault) {
%>
<div id="middle">
        <h2><fmt:message key="activate.security"/></h2>
    <div id="workArea">

        <form method="post" action="add-security.jsp" name="dataForm"
              onsubmit="return doValidation()">
            <input type="hidden" name="scenarioId" id="scenarioId"
                   value="<%= scenId%>"/>
            <%
                if (category.contains("ut")) {
            %>
            <table id="ut" class="styledLeft">
                <thead>
                <tr>
                    <th><fmt:message key="user.groups"/></th>
                </tr>
                </thead>
                <tbody>
                <tr>
                    <td class="formRow">
                        <table class="normal">
                            <%
                                if (groupData != null) {
                                    for (FlaggedName data : groupData) {
                                        if (data != null) { //Confusing!!. Sometimes a null object comes. Maybe a bug in Axis!!
                                            
                                            if(CarbonConstants.REGISTRY_ANONNYMOUS_ROLE_NAME.equals(data.getItemName())) {
                                                continue;
                                            }
                                            
                                            String checked = "";
                                            if (curr_ugs.contains(data.getItemName())) {
                                                checked = "checked=\"checked\"";
                                            }
                            %>
                            <tr>
                                <td><input type="checkbox" name="userGroups"
                                           value="<%=data.getItemName()%>" <%=checked%>/> <%=data.getItemName()%>
                                </td>
                            </tr>
                            <%
                                        }
                                    }
                                }
                            %>
                        </table>
                    </td>
                </tr>
                </tbody>
            </table>
            <%
                }

            %>
            <%

                if (category.contains("keystore")) {
            %>
            <table id="trtks" class="styledLeft">
                <thead>
                <tr>
                    <th><fmt:message key="trusted.key.stores"/></th>
                </tr>
                </thead>
                <tbody>
                <tr>
                    <td class="formRow">
                        <table class="normal">
                            <%
                                if (datas != null) {
                                    for (KeyStoreData data : datas) {
                                        if (data != null) { //Confusing!!. Sometimes a null object comes. Maybe a bug in Axis!!

                                            String checked = "";
                                            if (curr_tstks.contains(data.getKeyStoreName())) {
                                                checked = "checked=\"checked\"";
                                            }
                            %>
                            <tr>
                                <td><input type="checkbox" name="trustStore"
                                           value="<%=data.getKeyStoreName()%>" <%=checked%>/> <%=data.getKeyStoreName()%>
                                </td>
                            </tr>
                            <%
                                        }
                                    }
                                }
                            %>
                        </table>
                    </td>
                </tr>
                </tbody>
            </table>
            <table id="pvtks" class="styledLeft">
                <thead>
                <tr>
                    <th><fmt:message key="private.key.store"/></th>
                </tr>
                </thead>
                <tbody>
                <tr>
                    <td class="formRow">
                        <table class="normal">
                            <tr>
                                <td>
                                    <select name="privateStore">
                                        <%
                                            if (datas != null) {
                                                for (KeyStoreData data : datas) {
                                                    if (data != null && data.getPrivateStore()) {
                                                        String selected = "";
                                                        if (data.getKeyStoreName().equals(curr_pvtks)) {
                                                            selected = "selected=\"selected\"";
                                                        }

                                        %>
                                        <option value="<%=data.getKeyStoreName()%>" <%=selected %>><%=data.getKeyStoreName()%>
                                        </option>
                                        <%
                                                    }
                                                }
                                            }
                                        %>
                                    </select>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
                </tbody>
            </table>
            <%
                }
            %>
            <p></p>
            <table class="styledLeft">
                <tr class="buttonRow">
                    <td>
                        <input class="button" type="submit" value="<fmt:message key="finish"/>"/>
                        <input class="button" type="button" value="<fmt:message key="cancel"/>"
                               onclick="location.href = 'index.jsp?ordinal=2'"/>
                    </td>
                </tr>
            </table>
            <%

            %>
        </form>
    </div>
</div>
<%
    }
%>
</fmt:bundle>